# coding: utf-8

"""
    Open Bank Project API

    An Open Source API for Banks. (c) TESOBE GmbH. 2011 - 2023. Licensed under the AGPL and commercial licences.  # noqa: E501

    OpenAPI spec version: v5.0.0
    Contact: contact@tesobe.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from obp_python.configuration import Configuration


class CounterpartyWithMetadataJson400(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'other_account_routing_address': 'str',
        'other_account_routing_scheme': 'str',
        'created_by_user_id': 'str',
        'name': 'str',
        'other_account_secondary_routing_address': 'str',
        'is_beneficiary': 'bool',
        'description': 'str',
        'other_branch_routing_address': 'str',
        'bespoke': 'list[PostCounterpartyBespokeJson]',
        'other_bank_routing_scheme': 'str',
        'other_branch_routing_scheme': 'str',
        'this_account_id': 'str',
        'this_view_id': 'str',
        'currency': 'str',
        'metadata': 'CounterpartyMetadataJson',
        'other_bank_routing_address': 'str',
        'this_bank_id': 'str',
        'counterparty_id': 'str',
        'other_account_secondary_routing_scheme': 'str'
    }

    attribute_map = {
        'other_account_routing_address': 'other_account_routing_address',
        'other_account_routing_scheme': 'other_account_routing_scheme',
        'created_by_user_id': 'created_by_user_id',
        'name': 'name',
        'other_account_secondary_routing_address': 'other_account_secondary_routing_address',
        'is_beneficiary': 'is_beneficiary',
        'description': 'description',
        'other_branch_routing_address': 'other_branch_routing_address',
        'bespoke': 'bespoke',
        'other_bank_routing_scheme': 'other_bank_routing_scheme',
        'other_branch_routing_scheme': 'other_branch_routing_scheme',
        'this_account_id': 'this_account_id',
        'this_view_id': 'this_view_id',
        'currency': 'currency',
        'metadata': 'metadata',
        'other_bank_routing_address': 'other_bank_routing_address',
        'this_bank_id': 'this_bank_id',
        'counterparty_id': 'counterparty_id',
        'other_account_secondary_routing_scheme': 'other_account_secondary_routing_scheme'
    }

    def __init__(self, other_account_routing_address=None, other_account_routing_scheme=None, created_by_user_id=None, name=None, other_account_secondary_routing_address=None, is_beneficiary=None, description=None, other_branch_routing_address=None, bespoke=None, other_bank_routing_scheme=None, other_branch_routing_scheme=None, this_account_id=None, this_view_id=None, currency=None, metadata=None, other_bank_routing_address=None, this_bank_id=None, counterparty_id=None, other_account_secondary_routing_scheme=None, _configuration=None):  # noqa: E501
        """CounterpartyWithMetadataJson400 - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._other_account_routing_address = None
        self._other_account_routing_scheme = None
        self._created_by_user_id = None
        self._name = None
        self._other_account_secondary_routing_address = None
        self._is_beneficiary = None
        self._description = None
        self._other_branch_routing_address = None
        self._bespoke = None
        self._other_bank_routing_scheme = None
        self._other_branch_routing_scheme = None
        self._this_account_id = None
        self._this_view_id = None
        self._currency = None
        self._metadata = None
        self._other_bank_routing_address = None
        self._this_bank_id = None
        self._counterparty_id = None
        self._other_account_secondary_routing_scheme = None
        self.discriminator = None

        self.other_account_routing_address = other_account_routing_address
        self.other_account_routing_scheme = other_account_routing_scheme
        self.created_by_user_id = created_by_user_id
        self.name = name
        self.other_account_secondary_routing_address = other_account_secondary_routing_address
        self.is_beneficiary = is_beneficiary
        self.description = description
        self.other_branch_routing_address = other_branch_routing_address
        self.bespoke = bespoke
        self.other_bank_routing_scheme = other_bank_routing_scheme
        self.other_branch_routing_scheme = other_branch_routing_scheme
        self.this_account_id = this_account_id
        self.this_view_id = this_view_id
        self.currency = currency
        self.metadata = metadata
        self.other_bank_routing_address = other_bank_routing_address
        self.this_bank_id = this_bank_id
        self.counterparty_id = counterparty_id
        self.other_account_secondary_routing_scheme = other_account_secondary_routing_scheme

    @property
    def other_account_routing_address(self):
        """Gets the other_account_routing_address of this CounterpartyWithMetadataJson400.  # noqa: E501


        :return: The other_account_routing_address of this CounterpartyWithMetadataJson400.  # noqa: E501
        :rtype: str
        """
        return self._other_account_routing_address

    @other_account_routing_address.setter
    def other_account_routing_address(self, other_account_routing_address):
        """Sets the other_account_routing_address of this CounterpartyWithMetadataJson400.


        :param other_account_routing_address: The other_account_routing_address of this CounterpartyWithMetadataJson400.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and other_account_routing_address is None:
            raise ValueError("Invalid value for `other_account_routing_address`, must not be `None`")  # noqa: E501

        self._other_account_routing_address = other_account_routing_address

    @property
    def other_account_routing_scheme(self):
        """Gets the other_account_routing_scheme of this CounterpartyWithMetadataJson400.  # noqa: E501


        :return: The other_account_routing_scheme of this CounterpartyWithMetadataJson400.  # noqa: E501
        :rtype: str
        """
        return self._other_account_routing_scheme

    @other_account_routing_scheme.setter
    def other_account_routing_scheme(self, other_account_routing_scheme):
        """Sets the other_account_routing_scheme of this CounterpartyWithMetadataJson400.


        :param other_account_routing_scheme: The other_account_routing_scheme of this CounterpartyWithMetadataJson400.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and other_account_routing_scheme is None:
            raise ValueError("Invalid value for `other_account_routing_scheme`, must not be `None`")  # noqa: E501

        self._other_account_routing_scheme = other_account_routing_scheme

    @property
    def created_by_user_id(self):
        """Gets the created_by_user_id of this CounterpartyWithMetadataJson400.  # noqa: E501


        :return: The created_by_user_id of this CounterpartyWithMetadataJson400.  # noqa: E501
        :rtype: str
        """
        return self._created_by_user_id

    @created_by_user_id.setter
    def created_by_user_id(self, created_by_user_id):
        """Sets the created_by_user_id of this CounterpartyWithMetadataJson400.


        :param created_by_user_id: The created_by_user_id of this CounterpartyWithMetadataJson400.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and created_by_user_id is None:
            raise ValueError("Invalid value for `created_by_user_id`, must not be `None`")  # noqa: E501

        self._created_by_user_id = created_by_user_id

    @property
    def name(self):
        """Gets the name of this CounterpartyWithMetadataJson400.  # noqa: E501


        :return: The name of this CounterpartyWithMetadataJson400.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this CounterpartyWithMetadataJson400.


        :param name: The name of this CounterpartyWithMetadataJson400.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def other_account_secondary_routing_address(self):
        """Gets the other_account_secondary_routing_address of this CounterpartyWithMetadataJson400.  # noqa: E501


        :return: The other_account_secondary_routing_address of this CounterpartyWithMetadataJson400.  # noqa: E501
        :rtype: str
        """
        return self._other_account_secondary_routing_address

    @other_account_secondary_routing_address.setter
    def other_account_secondary_routing_address(self, other_account_secondary_routing_address):
        """Sets the other_account_secondary_routing_address of this CounterpartyWithMetadataJson400.


        :param other_account_secondary_routing_address: The other_account_secondary_routing_address of this CounterpartyWithMetadataJson400.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and other_account_secondary_routing_address is None:
            raise ValueError("Invalid value for `other_account_secondary_routing_address`, must not be `None`")  # noqa: E501

        self._other_account_secondary_routing_address = other_account_secondary_routing_address

    @property
    def is_beneficiary(self):
        """Gets the is_beneficiary of this CounterpartyWithMetadataJson400.  # noqa: E501


        :return: The is_beneficiary of this CounterpartyWithMetadataJson400.  # noqa: E501
        :rtype: bool
        """
        return self._is_beneficiary

    @is_beneficiary.setter
    def is_beneficiary(self, is_beneficiary):
        """Sets the is_beneficiary of this CounterpartyWithMetadataJson400.


        :param is_beneficiary: The is_beneficiary of this CounterpartyWithMetadataJson400.  # noqa: E501
        :type: bool
        """
        if self._configuration.client_side_validation and is_beneficiary is None:
            raise ValueError("Invalid value for `is_beneficiary`, must not be `None`")  # noqa: E501

        self._is_beneficiary = is_beneficiary

    @property
    def description(self):
        """Gets the description of this CounterpartyWithMetadataJson400.  # noqa: E501


        :return: The description of this CounterpartyWithMetadataJson400.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this CounterpartyWithMetadataJson400.


        :param description: The description of this CounterpartyWithMetadataJson400.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and description is None:
            raise ValueError("Invalid value for `description`, must not be `None`")  # noqa: E501

        self._description = description

    @property
    def other_branch_routing_address(self):
        """Gets the other_branch_routing_address of this CounterpartyWithMetadataJson400.  # noqa: E501


        :return: The other_branch_routing_address of this CounterpartyWithMetadataJson400.  # noqa: E501
        :rtype: str
        """
        return self._other_branch_routing_address

    @other_branch_routing_address.setter
    def other_branch_routing_address(self, other_branch_routing_address):
        """Sets the other_branch_routing_address of this CounterpartyWithMetadataJson400.


        :param other_branch_routing_address: The other_branch_routing_address of this CounterpartyWithMetadataJson400.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and other_branch_routing_address is None:
            raise ValueError("Invalid value for `other_branch_routing_address`, must not be `None`")  # noqa: E501

        self._other_branch_routing_address = other_branch_routing_address

    @property
    def bespoke(self):
        """Gets the bespoke of this CounterpartyWithMetadataJson400.  # noqa: E501


        :return: The bespoke of this CounterpartyWithMetadataJson400.  # noqa: E501
        :rtype: list[PostCounterpartyBespokeJson]
        """
        return self._bespoke

    @bespoke.setter
    def bespoke(self, bespoke):
        """Sets the bespoke of this CounterpartyWithMetadataJson400.


        :param bespoke: The bespoke of this CounterpartyWithMetadataJson400.  # noqa: E501
        :type: list[PostCounterpartyBespokeJson]
        """
        if self._configuration.client_side_validation and bespoke is None:
            raise ValueError("Invalid value for `bespoke`, must not be `None`")  # noqa: E501

        self._bespoke = bespoke

    @property
    def other_bank_routing_scheme(self):
        """Gets the other_bank_routing_scheme of this CounterpartyWithMetadataJson400.  # noqa: E501


        :return: The other_bank_routing_scheme of this CounterpartyWithMetadataJson400.  # noqa: E501
        :rtype: str
        """
        return self._other_bank_routing_scheme

    @other_bank_routing_scheme.setter
    def other_bank_routing_scheme(self, other_bank_routing_scheme):
        """Sets the other_bank_routing_scheme of this CounterpartyWithMetadataJson400.


        :param other_bank_routing_scheme: The other_bank_routing_scheme of this CounterpartyWithMetadataJson400.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and other_bank_routing_scheme is None:
            raise ValueError("Invalid value for `other_bank_routing_scheme`, must not be `None`")  # noqa: E501

        self._other_bank_routing_scheme = other_bank_routing_scheme

    @property
    def other_branch_routing_scheme(self):
        """Gets the other_branch_routing_scheme of this CounterpartyWithMetadataJson400.  # noqa: E501


        :return: The other_branch_routing_scheme of this CounterpartyWithMetadataJson400.  # noqa: E501
        :rtype: str
        """
        return self._other_branch_routing_scheme

    @other_branch_routing_scheme.setter
    def other_branch_routing_scheme(self, other_branch_routing_scheme):
        """Sets the other_branch_routing_scheme of this CounterpartyWithMetadataJson400.


        :param other_branch_routing_scheme: The other_branch_routing_scheme of this CounterpartyWithMetadataJson400.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and other_branch_routing_scheme is None:
            raise ValueError("Invalid value for `other_branch_routing_scheme`, must not be `None`")  # noqa: E501

        self._other_branch_routing_scheme = other_branch_routing_scheme

    @property
    def this_account_id(self):
        """Gets the this_account_id of this CounterpartyWithMetadataJson400.  # noqa: E501


        :return: The this_account_id of this CounterpartyWithMetadataJson400.  # noqa: E501
        :rtype: str
        """
        return self._this_account_id

    @this_account_id.setter
    def this_account_id(self, this_account_id):
        """Sets the this_account_id of this CounterpartyWithMetadataJson400.


        :param this_account_id: The this_account_id of this CounterpartyWithMetadataJson400.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and this_account_id is None:
            raise ValueError("Invalid value for `this_account_id`, must not be `None`")  # noqa: E501

        self._this_account_id = this_account_id

    @property
    def this_view_id(self):
        """Gets the this_view_id of this CounterpartyWithMetadataJson400.  # noqa: E501


        :return: The this_view_id of this CounterpartyWithMetadataJson400.  # noqa: E501
        :rtype: str
        """
        return self._this_view_id

    @this_view_id.setter
    def this_view_id(self, this_view_id):
        """Sets the this_view_id of this CounterpartyWithMetadataJson400.


        :param this_view_id: The this_view_id of this CounterpartyWithMetadataJson400.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and this_view_id is None:
            raise ValueError("Invalid value for `this_view_id`, must not be `None`")  # noqa: E501

        self._this_view_id = this_view_id

    @property
    def currency(self):
        """Gets the currency of this CounterpartyWithMetadataJson400.  # noqa: E501


        :return: The currency of this CounterpartyWithMetadataJson400.  # noqa: E501
        :rtype: str
        """
        return self._currency

    @currency.setter
    def currency(self, currency):
        """Sets the currency of this CounterpartyWithMetadataJson400.


        :param currency: The currency of this CounterpartyWithMetadataJson400.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and currency is None:
            raise ValueError("Invalid value for `currency`, must not be `None`")  # noqa: E501

        self._currency = currency

    @property
    def metadata(self):
        """Gets the metadata of this CounterpartyWithMetadataJson400.  # noqa: E501


        :return: The metadata of this CounterpartyWithMetadataJson400.  # noqa: E501
        :rtype: CounterpartyMetadataJson
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this CounterpartyWithMetadataJson400.


        :param metadata: The metadata of this CounterpartyWithMetadataJson400.  # noqa: E501
        :type: CounterpartyMetadataJson
        """
        if self._configuration.client_side_validation and metadata is None:
            raise ValueError("Invalid value for `metadata`, must not be `None`")  # noqa: E501

        self._metadata = metadata

    @property
    def other_bank_routing_address(self):
        """Gets the other_bank_routing_address of this CounterpartyWithMetadataJson400.  # noqa: E501


        :return: The other_bank_routing_address of this CounterpartyWithMetadataJson400.  # noqa: E501
        :rtype: str
        """
        return self._other_bank_routing_address

    @other_bank_routing_address.setter
    def other_bank_routing_address(self, other_bank_routing_address):
        """Sets the other_bank_routing_address of this CounterpartyWithMetadataJson400.


        :param other_bank_routing_address: The other_bank_routing_address of this CounterpartyWithMetadataJson400.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and other_bank_routing_address is None:
            raise ValueError("Invalid value for `other_bank_routing_address`, must not be `None`")  # noqa: E501

        self._other_bank_routing_address = other_bank_routing_address

    @property
    def this_bank_id(self):
        """Gets the this_bank_id of this CounterpartyWithMetadataJson400.  # noqa: E501


        :return: The this_bank_id of this CounterpartyWithMetadataJson400.  # noqa: E501
        :rtype: str
        """
        return self._this_bank_id

    @this_bank_id.setter
    def this_bank_id(self, this_bank_id):
        """Sets the this_bank_id of this CounterpartyWithMetadataJson400.


        :param this_bank_id: The this_bank_id of this CounterpartyWithMetadataJson400.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and this_bank_id is None:
            raise ValueError("Invalid value for `this_bank_id`, must not be `None`")  # noqa: E501

        self._this_bank_id = this_bank_id

    @property
    def counterparty_id(self):
        """Gets the counterparty_id of this CounterpartyWithMetadataJson400.  # noqa: E501


        :return: The counterparty_id of this CounterpartyWithMetadataJson400.  # noqa: E501
        :rtype: str
        """
        return self._counterparty_id

    @counterparty_id.setter
    def counterparty_id(self, counterparty_id):
        """Sets the counterparty_id of this CounterpartyWithMetadataJson400.


        :param counterparty_id: The counterparty_id of this CounterpartyWithMetadataJson400.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and counterparty_id is None:
            raise ValueError("Invalid value for `counterparty_id`, must not be `None`")  # noqa: E501

        self._counterparty_id = counterparty_id

    @property
    def other_account_secondary_routing_scheme(self):
        """Gets the other_account_secondary_routing_scheme of this CounterpartyWithMetadataJson400.  # noqa: E501


        :return: The other_account_secondary_routing_scheme of this CounterpartyWithMetadataJson400.  # noqa: E501
        :rtype: str
        """
        return self._other_account_secondary_routing_scheme

    @other_account_secondary_routing_scheme.setter
    def other_account_secondary_routing_scheme(self, other_account_secondary_routing_scheme):
        """Sets the other_account_secondary_routing_scheme of this CounterpartyWithMetadataJson400.


        :param other_account_secondary_routing_scheme: The other_account_secondary_routing_scheme of this CounterpartyWithMetadataJson400.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and other_account_secondary_routing_scheme is None:
            raise ValueError("Invalid value for `other_account_secondary_routing_scheme`, must not be `None`")  # noqa: E501

        self._other_account_secondary_routing_scheme = other_account_secondary_routing_scheme

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CounterpartyWithMetadataJson400, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CounterpartyWithMetadataJson400):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CounterpartyWithMetadataJson400):
            return True

        return self.to_dict() != other.to_dict()
