# coding: utf-8

"""
    Open Bank Project API

    An Open Source API for Banks. (c) TESOBE GmbH. 2011 - 2023. Licensed under the AGPL and commercial licences.  # noqa: E501

    OpenAPI spec version: v5.0.0
    Contact: contact@tesobe.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from obp_python.configuration import Configuration


class CreateMeetingJsonV310(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'provider_id': 'str',
        'creator': 'ContactDetailsJson',
        'invitees': 'list[InviteeJson]',
        '_date': 'date',
        'purpose_id': 'str'
    }

    attribute_map = {
        'provider_id': 'provider_id',
        'creator': 'creator',
        'invitees': 'invitees',
        '_date': 'date',
        'purpose_id': 'purpose_id'
    }

    def __init__(self, provider_id=None, creator=None, invitees=None, _date=None, purpose_id=None, _configuration=None):  # noqa: E501
        """CreateMeetingJsonV310 - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._provider_id = None
        self._creator = None
        self._invitees = None
        self.__date = None
        self._purpose_id = None
        self.discriminator = None

        self.provider_id = provider_id
        self.creator = creator
        self.invitees = invitees
        self._date = _date
        self.purpose_id = purpose_id

    @property
    def provider_id(self):
        """Gets the provider_id of this CreateMeetingJsonV310.  # noqa: E501


        :return: The provider_id of this CreateMeetingJsonV310.  # noqa: E501
        :rtype: str
        """
        return self._provider_id

    @provider_id.setter
    def provider_id(self, provider_id):
        """Sets the provider_id of this CreateMeetingJsonV310.


        :param provider_id: The provider_id of this CreateMeetingJsonV310.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and provider_id is None:
            raise ValueError("Invalid value for `provider_id`, must not be `None`")  # noqa: E501

        self._provider_id = provider_id

    @property
    def creator(self):
        """Gets the creator of this CreateMeetingJsonV310.  # noqa: E501


        :return: The creator of this CreateMeetingJsonV310.  # noqa: E501
        :rtype: ContactDetailsJson
        """
        return self._creator

    @creator.setter
    def creator(self, creator):
        """Sets the creator of this CreateMeetingJsonV310.


        :param creator: The creator of this CreateMeetingJsonV310.  # noqa: E501
        :type: ContactDetailsJson
        """
        if self._configuration.client_side_validation and creator is None:
            raise ValueError("Invalid value for `creator`, must not be `None`")  # noqa: E501

        self._creator = creator

    @property
    def invitees(self):
        """Gets the invitees of this CreateMeetingJsonV310.  # noqa: E501


        :return: The invitees of this CreateMeetingJsonV310.  # noqa: E501
        :rtype: list[InviteeJson]
        """
        return self._invitees

    @invitees.setter
    def invitees(self, invitees):
        """Sets the invitees of this CreateMeetingJsonV310.


        :param invitees: The invitees of this CreateMeetingJsonV310.  # noqa: E501
        :type: list[InviteeJson]
        """
        if self._configuration.client_side_validation and invitees is None:
            raise ValueError("Invalid value for `invitees`, must not be `None`")  # noqa: E501

        self._invitees = invitees

    @property
    def _date(self):
        """Gets the _date of this CreateMeetingJsonV310.  # noqa: E501


        :return: The _date of this CreateMeetingJsonV310.  # noqa: E501
        :rtype: date
        """
        return self.__date

    @_date.setter
    def _date(self, _date):
        """Sets the _date of this CreateMeetingJsonV310.


        :param _date: The _date of this CreateMeetingJsonV310.  # noqa: E501
        :type: date
        """
        if self._configuration.client_side_validation and _date is None:
            raise ValueError("Invalid value for `_date`, must not be `None`")  # noqa: E501

        self.__date = _date

    @property
    def purpose_id(self):
        """Gets the purpose_id of this CreateMeetingJsonV310.  # noqa: E501


        :return: The purpose_id of this CreateMeetingJsonV310.  # noqa: E501
        :rtype: str
        """
        return self._purpose_id

    @purpose_id.setter
    def purpose_id(self, purpose_id):
        """Sets the purpose_id of this CreateMeetingJsonV310.


        :param purpose_id: The purpose_id of this CreateMeetingJsonV310.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and purpose_id is None:
            raise ValueError("Invalid value for `purpose_id`, must not be `None`")  # noqa: E501

        self._purpose_id = purpose_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateMeetingJsonV310, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateMeetingJsonV310):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CreateMeetingJsonV310):
            return True

        return self.to_dict() != other.to_dict()
