# coding: utf-8

"""
    Open Bank Project API

    An Open Source API for Banks. (c) TESOBE GmbH. 2011 - 2023. Licensed under the AGPL and commercial licences.  # noqa: E501

    OpenAPI spec version: v5.0.0
    Contact: contact@tesobe.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from obp_python.configuration import Configuration


class EntitlementRequestJSON(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'entitlement_request_id': 'str',
        'role_name': 'str',
        'bank_id': 'str',
        'user': 'UserJsonV200',
        'created': 'date'
    }

    attribute_map = {
        'entitlement_request_id': 'entitlement_request_id',
        'role_name': 'role_name',
        'bank_id': 'bank_id',
        'user': 'user',
        'created': 'created'
    }

    def __init__(self, entitlement_request_id=None, role_name=None, bank_id=None, user=None, created=None, _configuration=None):  # noqa: E501
        """EntitlementRequestJSON - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._entitlement_request_id = None
        self._role_name = None
        self._bank_id = None
        self._user = None
        self._created = None
        self.discriminator = None

        self.entitlement_request_id = entitlement_request_id
        self.role_name = role_name
        self.bank_id = bank_id
        self.user = user
        self.created = created

    @property
    def entitlement_request_id(self):
        """Gets the entitlement_request_id of this EntitlementRequestJSON.  # noqa: E501


        :return: The entitlement_request_id of this EntitlementRequestJSON.  # noqa: E501
        :rtype: str
        """
        return self._entitlement_request_id

    @entitlement_request_id.setter
    def entitlement_request_id(self, entitlement_request_id):
        """Sets the entitlement_request_id of this EntitlementRequestJSON.


        :param entitlement_request_id: The entitlement_request_id of this EntitlementRequestJSON.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and entitlement_request_id is None:
            raise ValueError("Invalid value for `entitlement_request_id`, must not be `None`")  # noqa: E501

        self._entitlement_request_id = entitlement_request_id

    @property
    def role_name(self):
        """Gets the role_name of this EntitlementRequestJSON.  # noqa: E501


        :return: The role_name of this EntitlementRequestJSON.  # noqa: E501
        :rtype: str
        """
        return self._role_name

    @role_name.setter
    def role_name(self, role_name):
        """Sets the role_name of this EntitlementRequestJSON.


        :param role_name: The role_name of this EntitlementRequestJSON.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and role_name is None:
            raise ValueError("Invalid value for `role_name`, must not be `None`")  # noqa: E501

        self._role_name = role_name

    @property
    def bank_id(self):
        """Gets the bank_id of this EntitlementRequestJSON.  # noqa: E501


        :return: The bank_id of this EntitlementRequestJSON.  # noqa: E501
        :rtype: str
        """
        return self._bank_id

    @bank_id.setter
    def bank_id(self, bank_id):
        """Sets the bank_id of this EntitlementRequestJSON.


        :param bank_id: The bank_id of this EntitlementRequestJSON.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and bank_id is None:
            raise ValueError("Invalid value for `bank_id`, must not be `None`")  # noqa: E501

        self._bank_id = bank_id

    @property
    def user(self):
        """Gets the user of this EntitlementRequestJSON.  # noqa: E501


        :return: The user of this EntitlementRequestJSON.  # noqa: E501
        :rtype: UserJsonV200
        """
        return self._user

    @user.setter
    def user(self, user):
        """Sets the user of this EntitlementRequestJSON.


        :param user: The user of this EntitlementRequestJSON.  # noqa: E501
        :type: UserJsonV200
        """
        if self._configuration.client_side_validation and user is None:
            raise ValueError("Invalid value for `user`, must not be `None`")  # noqa: E501

        self._user = user

    @property
    def created(self):
        """Gets the created of this EntitlementRequestJSON.  # noqa: E501


        :return: The created of this EntitlementRequestJSON.  # noqa: E501
        :rtype: date
        """
        return self._created

    @created.setter
    def created(self, created):
        """Sets the created of this EntitlementRequestJSON.


        :param created: The created of this EntitlementRequestJSON.  # noqa: E501
        :type: date
        """
        if self._configuration.client_side_validation and created is None:
            raise ValueError("Invalid value for `created`, must not be `None`")  # noqa: E501

        self._created = created

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(EntitlementRequestJSON, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, EntitlementRequestJSON):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, EntitlementRequestJSON):
            return True

        return self.to_dict() != other.to_dict()
