# coding: utf-8

"""
    Open Bank Project API

    An Open Source API for Banks. (c) TESOBE GmbH. 2011 - 2023. Licensed under the AGPL and commercial licences.  # noqa: E501

    OpenAPI spec version: v5.0.0
    Contact: contact@tesobe.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from obp_python.configuration import Configuration


class MessageDocJson(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'adapter_implementation': 'AdapterImplementationJson',
        'outbound_avro_schema': 'MessageDocJsonOutboundAvroSchema',
        'example_inbound_message': 'MessageDocJsonOutboundAvroSchema',
        'inbound_avro_schema': 'MessageDocJsonOutboundAvroSchema',
        'required_field_info': 'FieldNameApiVersions',
        'description': 'str',
        'process': 'str',
        'message_format': 'str',
        'example_outbound_message': 'MessageDocJsonOutboundAvroSchema',
        'dependent_endpoints': 'list[EndpointInfo]',
        'outbound_topic': 'str',
        'inbound_topic': 'str'
    }

    attribute_map = {
        'adapter_implementation': 'adapter_implementation',
        'outbound_avro_schema': 'outboundAvroSchema',
        'example_inbound_message': 'example_inbound_message',
        'inbound_avro_schema': 'inboundAvroSchema',
        'required_field_info': 'requiredFieldInfo',
        'description': 'description',
        'process': 'process',
        'message_format': 'message_format',
        'example_outbound_message': 'example_outbound_message',
        'dependent_endpoints': 'dependent_endpoints',
        'outbound_topic': 'outbound_topic',
        'inbound_topic': 'inbound_topic'
    }

    def __init__(self, adapter_implementation=None, outbound_avro_schema=None, example_inbound_message=None, inbound_avro_schema=None, required_field_info=None, description=None, process=None, message_format=None, example_outbound_message=None, dependent_endpoints=None, outbound_topic=None, inbound_topic=None, _configuration=None):  # noqa: E501
        """MessageDocJson - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._adapter_implementation = None
        self._outbound_avro_schema = None
        self._example_inbound_message = None
        self._inbound_avro_schema = None
        self._required_field_info = None
        self._description = None
        self._process = None
        self._message_format = None
        self._example_outbound_message = None
        self._dependent_endpoints = None
        self._outbound_topic = None
        self._inbound_topic = None
        self.discriminator = None

        self.adapter_implementation = adapter_implementation
        if outbound_avro_schema is not None:
            self.outbound_avro_schema = outbound_avro_schema
        self.example_inbound_message = example_inbound_message
        if inbound_avro_schema is not None:
            self.inbound_avro_schema = inbound_avro_schema
        if required_field_info is not None:
            self.required_field_info = required_field_info
        self.description = description
        self.process = process
        self.message_format = message_format
        self.example_outbound_message = example_outbound_message
        self.dependent_endpoints = dependent_endpoints
        if outbound_topic is not None:
            self.outbound_topic = outbound_topic
        if inbound_topic is not None:
            self.inbound_topic = inbound_topic

    @property
    def adapter_implementation(self):
        """Gets the adapter_implementation of this MessageDocJson.  # noqa: E501


        :return: The adapter_implementation of this MessageDocJson.  # noqa: E501
        :rtype: AdapterImplementationJson
        """
        return self._adapter_implementation

    @adapter_implementation.setter
    def adapter_implementation(self, adapter_implementation):
        """Sets the adapter_implementation of this MessageDocJson.


        :param adapter_implementation: The adapter_implementation of this MessageDocJson.  # noqa: E501
        :type: AdapterImplementationJson
        """
        if self._configuration.client_side_validation and adapter_implementation is None:
            raise ValueError("Invalid value for `adapter_implementation`, must not be `None`")  # noqa: E501

        self._adapter_implementation = adapter_implementation

    @property
    def outbound_avro_schema(self):
        """Gets the outbound_avro_schema of this MessageDocJson.  # noqa: E501


        :return: The outbound_avro_schema of this MessageDocJson.  # noqa: E501
        :rtype: MessageDocJsonOutboundAvroSchema
        """
        return self._outbound_avro_schema

    @outbound_avro_schema.setter
    def outbound_avro_schema(self, outbound_avro_schema):
        """Sets the outbound_avro_schema of this MessageDocJson.


        :param outbound_avro_schema: The outbound_avro_schema of this MessageDocJson.  # noqa: E501
        :type: MessageDocJsonOutboundAvroSchema
        """

        self._outbound_avro_schema = outbound_avro_schema

    @property
    def example_inbound_message(self):
        """Gets the example_inbound_message of this MessageDocJson.  # noqa: E501


        :return: The example_inbound_message of this MessageDocJson.  # noqa: E501
        :rtype: MessageDocJsonOutboundAvroSchema
        """
        return self._example_inbound_message

    @example_inbound_message.setter
    def example_inbound_message(self, example_inbound_message):
        """Sets the example_inbound_message of this MessageDocJson.


        :param example_inbound_message: The example_inbound_message of this MessageDocJson.  # noqa: E501
        :type: MessageDocJsonOutboundAvroSchema
        """
        if self._configuration.client_side_validation and example_inbound_message is None:
            raise ValueError("Invalid value for `example_inbound_message`, must not be `None`")  # noqa: E501

        self._example_inbound_message = example_inbound_message

    @property
    def inbound_avro_schema(self):
        """Gets the inbound_avro_schema of this MessageDocJson.  # noqa: E501


        :return: The inbound_avro_schema of this MessageDocJson.  # noqa: E501
        :rtype: MessageDocJsonOutboundAvroSchema
        """
        return self._inbound_avro_schema

    @inbound_avro_schema.setter
    def inbound_avro_schema(self, inbound_avro_schema):
        """Sets the inbound_avro_schema of this MessageDocJson.


        :param inbound_avro_schema: The inbound_avro_schema of this MessageDocJson.  # noqa: E501
        :type: MessageDocJsonOutboundAvroSchema
        """

        self._inbound_avro_schema = inbound_avro_schema

    @property
    def required_field_info(self):
        """Gets the required_field_info of this MessageDocJson.  # noqa: E501


        :return: The required_field_info of this MessageDocJson.  # noqa: E501
        :rtype: FieldNameApiVersions
        """
        return self._required_field_info

    @required_field_info.setter
    def required_field_info(self, required_field_info):
        """Sets the required_field_info of this MessageDocJson.


        :param required_field_info: The required_field_info of this MessageDocJson.  # noqa: E501
        :type: FieldNameApiVersions
        """

        self._required_field_info = required_field_info

    @property
    def description(self):
        """Gets the description of this MessageDocJson.  # noqa: E501


        :return: The description of this MessageDocJson.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this MessageDocJson.


        :param description: The description of this MessageDocJson.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and description is None:
            raise ValueError("Invalid value for `description`, must not be `None`")  # noqa: E501

        self._description = description

    @property
    def process(self):
        """Gets the process of this MessageDocJson.  # noqa: E501


        :return: The process of this MessageDocJson.  # noqa: E501
        :rtype: str
        """
        return self._process

    @process.setter
    def process(self, process):
        """Sets the process of this MessageDocJson.


        :param process: The process of this MessageDocJson.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and process is None:
            raise ValueError("Invalid value for `process`, must not be `None`")  # noqa: E501

        self._process = process

    @property
    def message_format(self):
        """Gets the message_format of this MessageDocJson.  # noqa: E501


        :return: The message_format of this MessageDocJson.  # noqa: E501
        :rtype: str
        """
        return self._message_format

    @message_format.setter
    def message_format(self, message_format):
        """Sets the message_format of this MessageDocJson.


        :param message_format: The message_format of this MessageDocJson.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and message_format is None:
            raise ValueError("Invalid value for `message_format`, must not be `None`")  # noqa: E501

        self._message_format = message_format

    @property
    def example_outbound_message(self):
        """Gets the example_outbound_message of this MessageDocJson.  # noqa: E501


        :return: The example_outbound_message of this MessageDocJson.  # noqa: E501
        :rtype: MessageDocJsonOutboundAvroSchema
        """
        return self._example_outbound_message

    @example_outbound_message.setter
    def example_outbound_message(self, example_outbound_message):
        """Sets the example_outbound_message of this MessageDocJson.


        :param example_outbound_message: The example_outbound_message of this MessageDocJson.  # noqa: E501
        :type: MessageDocJsonOutboundAvroSchema
        """
        if self._configuration.client_side_validation and example_outbound_message is None:
            raise ValueError("Invalid value for `example_outbound_message`, must not be `None`")  # noqa: E501

        self._example_outbound_message = example_outbound_message

    @property
    def dependent_endpoints(self):
        """Gets the dependent_endpoints of this MessageDocJson.  # noqa: E501


        :return: The dependent_endpoints of this MessageDocJson.  # noqa: E501
        :rtype: list[EndpointInfo]
        """
        return self._dependent_endpoints

    @dependent_endpoints.setter
    def dependent_endpoints(self, dependent_endpoints):
        """Sets the dependent_endpoints of this MessageDocJson.


        :param dependent_endpoints: The dependent_endpoints of this MessageDocJson.  # noqa: E501
        :type: list[EndpointInfo]
        """
        if self._configuration.client_side_validation and dependent_endpoints is None:
            raise ValueError("Invalid value for `dependent_endpoints`, must not be `None`")  # noqa: E501

        self._dependent_endpoints = dependent_endpoints

    @property
    def outbound_topic(self):
        """Gets the outbound_topic of this MessageDocJson.  # noqa: E501


        :return: The outbound_topic of this MessageDocJson.  # noqa: E501
        :rtype: str
        """
        return self._outbound_topic

    @outbound_topic.setter
    def outbound_topic(self, outbound_topic):
        """Sets the outbound_topic of this MessageDocJson.


        :param outbound_topic: The outbound_topic of this MessageDocJson.  # noqa: E501
        :type: str
        """

        self._outbound_topic = outbound_topic

    @property
    def inbound_topic(self):
        """Gets the inbound_topic of this MessageDocJson.  # noqa: E501


        :return: The inbound_topic of this MessageDocJson.  # noqa: E501
        :rtype: str
        """
        return self._inbound_topic

    @inbound_topic.setter
    def inbound_topic(self, inbound_topic):
        """Sets the inbound_topic of this MessageDocJson.


        :param inbound_topic: The inbound_topic of this MessageDocJson.  # noqa: E501
        :type: str
        """

        self._inbound_topic = inbound_topic

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(MessageDocJson, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MessageDocJson):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, MessageDocJson):
            return True

        return self.to_dict() != other.to_dict()
