# coding: utf-8

"""
    Open Bank Project API

    An Open Source API for Banks. (c) TESOBE GmbH. 2011 - 2023. Licensed under the AGPL and commercial licences.  # noqa: E501

    OpenAPI spec version: v5.0.0
    Contact: contact@tesobe.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from obp_python.configuration import Configuration


class PostBankJson500(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'bank_routings': 'list[BankRoutingJsonV121]',
        'website': 'str',
        'full_name': 'str',
        'logo': 'str',
        'id': 'str',
        'bank_code': 'str'
    }

    attribute_map = {
        'bank_routings': 'bank_routings',
        'website': 'website',
        'full_name': 'full_name',
        'logo': 'logo',
        'id': 'id',
        'bank_code': 'bank_code'
    }

    def __init__(self, bank_routings=None, website=None, full_name=None, logo=None, id=None, bank_code=None, _configuration=None):  # noqa: E501
        """PostBankJson500 - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._bank_routings = None
        self._website = None
        self._full_name = None
        self._logo = None
        self._id = None
        self._bank_code = None
        self.discriminator = None

        if bank_routings is not None:
            self.bank_routings = bank_routings
        if website is not None:
            self.website = website
        if full_name is not None:
            self.full_name = full_name
        if logo is not None:
            self.logo = logo
        if id is not None:
            self.id = id
        self.bank_code = bank_code

    @property
    def bank_routings(self):
        """Gets the bank_routings of this PostBankJson500.  # noqa: E501


        :return: The bank_routings of this PostBankJson500.  # noqa: E501
        :rtype: list[BankRoutingJsonV121]
        """
        return self._bank_routings

    @bank_routings.setter
    def bank_routings(self, bank_routings):
        """Sets the bank_routings of this PostBankJson500.


        :param bank_routings: The bank_routings of this PostBankJson500.  # noqa: E501
        :type: list[BankRoutingJsonV121]
        """

        self._bank_routings = bank_routings

    @property
    def website(self):
        """Gets the website of this PostBankJson500.  # noqa: E501


        :return: The website of this PostBankJson500.  # noqa: E501
        :rtype: str
        """
        return self._website

    @website.setter
    def website(self, website):
        """Sets the website of this PostBankJson500.


        :param website: The website of this PostBankJson500.  # noqa: E501
        :type: str
        """

        self._website = website

    @property
    def full_name(self):
        """Gets the full_name of this PostBankJson500.  # noqa: E501


        :return: The full_name of this PostBankJson500.  # noqa: E501
        :rtype: str
        """
        return self._full_name

    @full_name.setter
    def full_name(self, full_name):
        """Sets the full_name of this PostBankJson500.


        :param full_name: The full_name of this PostBankJson500.  # noqa: E501
        :type: str
        """

        self._full_name = full_name

    @property
    def logo(self):
        """Gets the logo of this PostBankJson500.  # noqa: E501


        :return: The logo of this PostBankJson500.  # noqa: E501
        :rtype: str
        """
        return self._logo

    @logo.setter
    def logo(self, logo):
        """Sets the logo of this PostBankJson500.


        :param logo: The logo of this PostBankJson500.  # noqa: E501
        :type: str
        """

        self._logo = logo

    @property
    def id(self):
        """Gets the id of this PostBankJson500.  # noqa: E501


        :return: The id of this PostBankJson500.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this PostBankJson500.


        :param id: The id of this PostBankJson500.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def bank_code(self):
        """Gets the bank_code of this PostBankJson500.  # noqa: E501


        :return: The bank_code of this PostBankJson500.  # noqa: E501
        :rtype: str
        """
        return self._bank_code

    @bank_code.setter
    def bank_code(self, bank_code):
        """Sets the bank_code of this PostBankJson500.


        :param bank_code: The bank_code of this PostBankJson500.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and bank_code is None:
            raise ValueError("Invalid value for `bank_code`, must not be `None`")  # noqa: E501

        self._bank_code = bank_code

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PostBankJson500, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PostBankJson500):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PostBankJson500):
            return True

        return self.to_dict() != other.to_dict()
