# coding: utf-8

"""
    Open Bank Project API

    An Open Source API for Banks. (c) TESOBE GmbH. 2011 - 2023. Licensed under the AGPL and commercial licences.  # noqa: E501

    OpenAPI spec version: v5.0.0
    Contact: contact@tesobe.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from obp_python.configuration import Configuration


class SandboxTransactionImport(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'this_account': 'SandboxAccountIdImport',
        'counterparty': 'SandboxTransactionCounterparty',
        'details': 'SandboxAccountDetailsImport'
    }

    attribute_map = {
        'id': 'id',
        'this_account': 'this_account',
        'counterparty': 'counterparty',
        'details': 'details'
    }

    def __init__(self, id=None, this_account=None, counterparty=None, details=None, _configuration=None):  # noqa: E501
        """SandboxTransactionImport - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._id = None
        self._this_account = None
        self._counterparty = None
        self._details = None
        self.discriminator = None

        self.id = id
        self.this_account = this_account
        if counterparty is not None:
            self.counterparty = counterparty
        self.details = details

    @property
    def id(self):
        """Gets the id of this SandboxTransactionImport.  # noqa: E501


        :return: The id of this SandboxTransactionImport.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this SandboxTransactionImport.


        :param id: The id of this SandboxTransactionImport.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def this_account(self):
        """Gets the this_account of this SandboxTransactionImport.  # noqa: E501


        :return: The this_account of this SandboxTransactionImport.  # noqa: E501
        :rtype: SandboxAccountIdImport
        """
        return self._this_account

    @this_account.setter
    def this_account(self, this_account):
        """Sets the this_account of this SandboxTransactionImport.


        :param this_account: The this_account of this SandboxTransactionImport.  # noqa: E501
        :type: SandboxAccountIdImport
        """
        if self._configuration.client_side_validation and this_account is None:
            raise ValueError("Invalid value for `this_account`, must not be `None`")  # noqa: E501

        self._this_account = this_account

    @property
    def counterparty(self):
        """Gets the counterparty of this SandboxTransactionImport.  # noqa: E501


        :return: The counterparty of this SandboxTransactionImport.  # noqa: E501
        :rtype: SandboxTransactionCounterparty
        """
        return self._counterparty

    @counterparty.setter
    def counterparty(self, counterparty):
        """Sets the counterparty of this SandboxTransactionImport.


        :param counterparty: The counterparty of this SandboxTransactionImport.  # noqa: E501
        :type: SandboxTransactionCounterparty
        """

        self._counterparty = counterparty

    @property
    def details(self):
        """Gets the details of this SandboxTransactionImport.  # noqa: E501


        :return: The details of this SandboxTransactionImport.  # noqa: E501
        :rtype: SandboxAccountDetailsImport
        """
        return self._details

    @details.setter
    def details(self, details):
        """Sets the details of this SandboxTransactionImport.


        :param details: The details of this SandboxTransactionImport.  # noqa: E501
        :type: SandboxAccountDetailsImport
        """
        if self._configuration.client_side_validation and details is None:
            raise ValueError("Invalid value for `details`, must not be `None`")  # noqa: E501

        self._details = details

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SandboxTransactionImport, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SandboxTransactionImport):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SandboxTransactionImport):
            return True

        return self.to_dict() != other.to_dict()
