# coding: utf-8

"""
    Open Bank Project API

    An Open Source API for Banks. (c) TESOBE GmbH. 2011 - 2023. Licensed under the AGPL and commercial licences.  # noqa: E501

    OpenAPI spec version: v5.0.0
    Contact: contact@tesobe.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from obp_python.configuration import Configuration


class SepaCreditTransfers(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'debtor_account': 'PaymentAccount',
        'instructed_amount': 'AmountOfMoneyJsonV121',
        'creditor_account': 'PaymentAccount',
        'creditor_name': 'str'
    }

    attribute_map = {
        'debtor_account': 'debtorAccount',
        'instructed_amount': 'instructedAmount',
        'creditor_account': 'creditorAccount',
        'creditor_name': 'creditorName'
    }

    def __init__(self, debtor_account=None, instructed_amount=None, creditor_account=None, creditor_name=None, _configuration=None):  # noqa: E501
        """SepaCreditTransfers - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._debtor_account = None
        self._instructed_amount = None
        self._creditor_account = None
        self._creditor_name = None
        self.discriminator = None

        self.debtor_account = debtor_account
        self.instructed_amount = instructed_amount
        self.creditor_account = creditor_account
        self.creditor_name = creditor_name

    @property
    def debtor_account(self):
        """Gets the debtor_account of this SepaCreditTransfers.  # noqa: E501


        :return: The debtor_account of this SepaCreditTransfers.  # noqa: E501
        :rtype: PaymentAccount
        """
        return self._debtor_account

    @debtor_account.setter
    def debtor_account(self, debtor_account):
        """Sets the debtor_account of this SepaCreditTransfers.


        :param debtor_account: The debtor_account of this SepaCreditTransfers.  # noqa: E501
        :type: PaymentAccount
        """
        if self._configuration.client_side_validation and debtor_account is None:
            raise ValueError("Invalid value for `debtor_account`, must not be `None`")  # noqa: E501

        self._debtor_account = debtor_account

    @property
    def instructed_amount(self):
        """Gets the instructed_amount of this SepaCreditTransfers.  # noqa: E501


        :return: The instructed_amount of this SepaCreditTransfers.  # noqa: E501
        :rtype: AmountOfMoneyJsonV121
        """
        return self._instructed_amount

    @instructed_amount.setter
    def instructed_amount(self, instructed_amount):
        """Sets the instructed_amount of this SepaCreditTransfers.


        :param instructed_amount: The instructed_amount of this SepaCreditTransfers.  # noqa: E501
        :type: AmountOfMoneyJsonV121
        """
        if self._configuration.client_side_validation and instructed_amount is None:
            raise ValueError("Invalid value for `instructed_amount`, must not be `None`")  # noqa: E501

        self._instructed_amount = instructed_amount

    @property
    def creditor_account(self):
        """Gets the creditor_account of this SepaCreditTransfers.  # noqa: E501


        :return: The creditor_account of this SepaCreditTransfers.  # noqa: E501
        :rtype: PaymentAccount
        """
        return self._creditor_account

    @creditor_account.setter
    def creditor_account(self, creditor_account):
        """Sets the creditor_account of this SepaCreditTransfers.


        :param creditor_account: The creditor_account of this SepaCreditTransfers.  # noqa: E501
        :type: PaymentAccount
        """
        if self._configuration.client_side_validation and creditor_account is None:
            raise ValueError("Invalid value for `creditor_account`, must not be `None`")  # noqa: E501

        self._creditor_account = creditor_account

    @property
    def creditor_name(self):
        """Gets the creditor_name of this SepaCreditTransfers.  # noqa: E501


        :return: The creditor_name of this SepaCreditTransfers.  # noqa: E501
        :rtype: str
        """
        return self._creditor_name

    @creditor_name.setter
    def creditor_name(self, creditor_name):
        """Sets the creditor_name of this SepaCreditTransfers.


        :param creditor_name: The creditor_name of this SepaCreditTransfers.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and creditor_name is None:
            raise ValueError("Invalid value for `creditor_name`, must not be `None`")  # noqa: E501

        self._creditor_name = creditor_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SepaCreditTransfers, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SepaCreditTransfers):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SepaCreditTransfers):
            return True

        return self.to_dict() != other.to_dict()
