# coding: utf-8

"""
    Open Bank Project API

    An Open Source API for Banks. (c) TESOBE GmbH. 2011 - 2023. Licensed under the AGPL and commercial licences.  # noqa: E501

    OpenAPI spec version: v5.0.0
    Contact: contact@tesobe.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from obp_python.configuration import Configuration


class TransactionRequestBodyCardJsonV400(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'card': 'CardJsonV400',
        'to': 'CounterpartyIdJson',
        'value': 'AmountOfMoneyJsonV121',
        'description': 'str'
    }

    attribute_map = {
        'card': 'card',
        'to': 'to',
        'value': 'value',
        'description': 'description'
    }

    def __init__(self, card=None, to=None, value=None, description=None, _configuration=None):  # noqa: E501
        """TransactionRequestBodyCardJsonV400 - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._card = None
        self._to = None
        self._value = None
        self._description = None
        self.discriminator = None

        self.card = card
        self.to = to
        self.value = value
        self.description = description

    @property
    def card(self):
        """Gets the card of this TransactionRequestBodyCardJsonV400.  # noqa: E501


        :return: The card of this TransactionRequestBodyCardJsonV400.  # noqa: E501
        :rtype: CardJsonV400
        """
        return self._card

    @card.setter
    def card(self, card):
        """Sets the card of this TransactionRequestBodyCardJsonV400.


        :param card: The card of this TransactionRequestBodyCardJsonV400.  # noqa: E501
        :type: CardJsonV400
        """
        if self._configuration.client_side_validation and card is None:
            raise ValueError("Invalid value for `card`, must not be `None`")  # noqa: E501

        self._card = card

    @property
    def to(self):
        """Gets the to of this TransactionRequestBodyCardJsonV400.  # noqa: E501


        :return: The to of this TransactionRequestBodyCardJsonV400.  # noqa: E501
        :rtype: CounterpartyIdJson
        """
        return self._to

    @to.setter
    def to(self, to):
        """Sets the to of this TransactionRequestBodyCardJsonV400.


        :param to: The to of this TransactionRequestBodyCardJsonV400.  # noqa: E501
        :type: CounterpartyIdJson
        """
        if self._configuration.client_side_validation and to is None:
            raise ValueError("Invalid value for `to`, must not be `None`")  # noqa: E501

        self._to = to

    @property
    def value(self):
        """Gets the value of this TransactionRequestBodyCardJsonV400.  # noqa: E501


        :return: The value of this TransactionRequestBodyCardJsonV400.  # noqa: E501
        :rtype: AmountOfMoneyJsonV121
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this TransactionRequestBodyCardJsonV400.


        :param value: The value of this TransactionRequestBodyCardJsonV400.  # noqa: E501
        :type: AmountOfMoneyJsonV121
        """
        if self._configuration.client_side_validation and value is None:
            raise ValueError("Invalid value for `value`, must not be `None`")  # noqa: E501

        self._value = value

    @property
    def description(self):
        """Gets the description of this TransactionRequestBodyCardJsonV400.  # noqa: E501


        :return: The description of this TransactionRequestBodyCardJsonV400.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this TransactionRequestBodyCardJsonV400.


        :param description: The description of this TransactionRequestBodyCardJsonV400.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and description is None:
            raise ValueError("Invalid value for `description`, must not be `None`")  # noqa: E501

        self._description = description

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(TransactionRequestBodyCardJsonV400, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TransactionRequestBodyCardJsonV400):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, TransactionRequestBodyCardJsonV400):
            return True

        return self.to_dict() != other.to_dict()
