# coding: utf-8

"""
    Open Bank Project API

    An Open Source API for Banks. (c) TESOBE GmbH. 2011 - 2023. Licensed under the AGPL and commercial licences.  # noqa: E501

    OpenAPI spec version: v5.0.0
    Contact: contact@tesobe.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from obp_python.configuration import Configuration


class TransactionRequestTransferToAccount(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'description': 'str',
        'future_date': 'str',
        'to': 'ToAccountTransferToAccount',
        'transfer_type': 'str',
        'value': 'AmountOfMoneyJsonV121'
    }

    attribute_map = {
        'description': 'description',
        'future_date': 'future_date',
        'to': 'to',
        'transfer_type': 'transfer_type',
        'value': 'value'
    }

    def __init__(self, description=None, future_date=None, to=None, transfer_type=None, value=None, _configuration=None):  # noqa: E501
        """TransactionRequestTransferToAccount - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._description = None
        self._future_date = None
        self._to = None
        self._transfer_type = None
        self._value = None
        self.discriminator = None

        self.description = description
        self.future_date = future_date
        self.to = to
        self.transfer_type = transfer_type
        self.value = value

    @property
    def description(self):
        """Gets the description of this TransactionRequestTransferToAccount.  # noqa: E501


        :return: The description of this TransactionRequestTransferToAccount.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this TransactionRequestTransferToAccount.


        :param description: The description of this TransactionRequestTransferToAccount.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and description is None:
            raise ValueError("Invalid value for `description`, must not be `None`")  # noqa: E501

        self._description = description

    @property
    def future_date(self):
        """Gets the future_date of this TransactionRequestTransferToAccount.  # noqa: E501


        :return: The future_date of this TransactionRequestTransferToAccount.  # noqa: E501
        :rtype: str
        """
        return self._future_date

    @future_date.setter
    def future_date(self, future_date):
        """Sets the future_date of this TransactionRequestTransferToAccount.


        :param future_date: The future_date of this TransactionRequestTransferToAccount.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and future_date is None:
            raise ValueError("Invalid value for `future_date`, must not be `None`")  # noqa: E501

        self._future_date = future_date

    @property
    def to(self):
        """Gets the to of this TransactionRequestTransferToAccount.  # noqa: E501


        :return: The to of this TransactionRequestTransferToAccount.  # noqa: E501
        :rtype: ToAccountTransferToAccount
        """
        return self._to

    @to.setter
    def to(self, to):
        """Sets the to of this TransactionRequestTransferToAccount.


        :param to: The to of this TransactionRequestTransferToAccount.  # noqa: E501
        :type: ToAccountTransferToAccount
        """
        if self._configuration.client_side_validation and to is None:
            raise ValueError("Invalid value for `to`, must not be `None`")  # noqa: E501

        self._to = to

    @property
    def transfer_type(self):
        """Gets the transfer_type of this TransactionRequestTransferToAccount.  # noqa: E501


        :return: The transfer_type of this TransactionRequestTransferToAccount.  # noqa: E501
        :rtype: str
        """
        return self._transfer_type

    @transfer_type.setter
    def transfer_type(self, transfer_type):
        """Sets the transfer_type of this TransactionRequestTransferToAccount.


        :param transfer_type: The transfer_type of this TransactionRequestTransferToAccount.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and transfer_type is None:
            raise ValueError("Invalid value for `transfer_type`, must not be `None`")  # noqa: E501

        self._transfer_type = transfer_type

    @property
    def value(self):
        """Gets the value of this TransactionRequestTransferToAccount.  # noqa: E501


        :return: The value of this TransactionRequestTransferToAccount.  # noqa: E501
        :rtype: AmountOfMoneyJsonV121
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this TransactionRequestTransferToAccount.


        :param value: The value of this TransactionRequestTransferToAccount.  # noqa: E501
        :type: AmountOfMoneyJsonV121
        """
        if self._configuration.client_side_validation and value is None:
            raise ValueError("Invalid value for `value`, must not be `None`")  # noqa: E501

        self._value = value

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(TransactionRequestTransferToAccount, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TransactionRequestTransferToAccount):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, TransactionRequestTransferToAccount):
            return True

        return self.to_dict() != other.to_dict()
