# coding: utf-8

"""
    Open Bank Project API

    An Open Source API for Banks. (c) TESOBE GmbH. 2011 - 2023. Licensed under the AGPL and commercial licences.  # noqa: E501

    OpenAPI spec version: v5.0.0
    Contact: contact@tesobe.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from obp_python.configuration import Configuration


class ConsentRequestResponseJsonPayload(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'everything': 'bool',
        'account_access': 'list[ConsentRequestResponseJsonPayloadAccountAccess]',
        'phone_number': 'str',
        'valid_from': 'str',
        'time_to_live': 'int'
    }

    attribute_map = {
        'everything': 'everything',
        'account_access': 'account_access',
        'phone_number': 'phone_number',
        'valid_from': 'valid_from',
        'time_to_live': 'time_to_live'
    }

    def __init__(self, everything=None, account_access=None, phone_number=None, valid_from=None, time_to_live=None, _configuration=None):  # noqa: E501
        """ConsentRequestResponseJsonPayload - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._everything = None
        self._account_access = None
        self._phone_number = None
        self._valid_from = None
        self._time_to_live = None
        self.discriminator = None

        self.everything = everything
        self.account_access = account_access
        self.phone_number = phone_number
        self.valid_from = valid_from
        self.time_to_live = time_to_live

    @property
    def everything(self):
        """Gets the everything of this ConsentRequestResponseJsonPayload.  # noqa: E501


        :return: The everything of this ConsentRequestResponseJsonPayload.  # noqa: E501
        :rtype: bool
        """
        return self._everything

    @everything.setter
    def everything(self, everything):
        """Sets the everything of this ConsentRequestResponseJsonPayload.


        :param everything: The everything of this ConsentRequestResponseJsonPayload.  # noqa: E501
        :type: bool
        """
        if self._configuration.client_side_validation and everything is None:
            raise ValueError("Invalid value for `everything`, must not be `None`")  # noqa: E501

        self._everything = everything

    @property
    def account_access(self):
        """Gets the account_access of this ConsentRequestResponseJsonPayload.  # noqa: E501


        :return: The account_access of this ConsentRequestResponseJsonPayload.  # noqa: E501
        :rtype: list[ConsentRequestResponseJsonPayloadAccountAccess]
        """
        return self._account_access

    @account_access.setter
    def account_access(self, account_access):
        """Sets the account_access of this ConsentRequestResponseJsonPayload.


        :param account_access: The account_access of this ConsentRequestResponseJsonPayload.  # noqa: E501
        :type: list[ConsentRequestResponseJsonPayloadAccountAccess]
        """
        if self._configuration.client_side_validation and account_access is None:
            raise ValueError("Invalid value for `account_access`, must not be `None`")  # noqa: E501

        self._account_access = account_access

    @property
    def phone_number(self):
        """Gets the phone_number of this ConsentRequestResponseJsonPayload.  # noqa: E501


        :return: The phone_number of this ConsentRequestResponseJsonPayload.  # noqa: E501
        :rtype: str
        """
        return self._phone_number

    @phone_number.setter
    def phone_number(self, phone_number):
        """Sets the phone_number of this ConsentRequestResponseJsonPayload.


        :param phone_number: The phone_number of this ConsentRequestResponseJsonPayload.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and phone_number is None:
            raise ValueError("Invalid value for `phone_number`, must not be `None`")  # noqa: E501

        self._phone_number = phone_number

    @property
    def valid_from(self):
        """Gets the valid_from of this ConsentRequestResponseJsonPayload.  # noqa: E501


        :return: The valid_from of this ConsentRequestResponseJsonPayload.  # noqa: E501
        :rtype: str
        """
        return self._valid_from

    @valid_from.setter
    def valid_from(self, valid_from):
        """Sets the valid_from of this ConsentRequestResponseJsonPayload.


        :param valid_from: The valid_from of this ConsentRequestResponseJsonPayload.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and valid_from is None:
            raise ValueError("Invalid value for `valid_from`, must not be `None`")  # noqa: E501

        self._valid_from = valid_from

    @property
    def time_to_live(self):
        """Gets the time_to_live of this ConsentRequestResponseJsonPayload.  # noqa: E501


        :return: The time_to_live of this ConsentRequestResponseJsonPayload.  # noqa: E501
        :rtype: int
        """
        return self._time_to_live

    @time_to_live.setter
    def time_to_live(self, time_to_live):
        """Sets the time_to_live of this ConsentRequestResponseJsonPayload.


        :param time_to_live: The time_to_live of this ConsentRequestResponseJsonPayload.  # noqa: E501
        :type: int
        """
        if self._configuration.client_side_validation and time_to_live is None:
            raise ValueError("Invalid value for `time_to_live`, must not be `None`")  # noqa: E501

        self._time_to_live = time_to_live

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ConsentRequestResponseJsonPayload, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ConsentRequestResponseJsonPayload):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ConsentRequestResponseJsonPayload):
            return True

        return self.to_dict() != other.to_dict()
